﻿
'_Template settings_________________________________________________________
' MyGen. Ver.: 1.3.0.9                                 
' Template   : Miranda x Vb.Net, ver. 1.8.4                                   
' Author     : Gianluca Pezzoli. @CopyRight 2010 Dott. Ing. Gianluca Pezzoli  
' DB Name    : test
' Table Name : tblconchiaveidentity
' Namespace  : <none>
' Entity     : tblconchiaveidentity
' FormBinding: Vero
' UndoChanges: Vero
' Language   : MySQL Connector/Net (VB.NET)
' DbTarget   : MySQL Connector/Net 
' User MetaDB: \\pezzolidell\e$\DatiNuovi\Clienti\Ambrosini\Applicazioni\Personale\Personale.Net\MyGen\UserMetaData.xml
' Created  on: 23/06/2010 18:15:03
'___________________________________________________________________________

Imports System
Imports System.ComponentModel
Imports Pezzoli.Data.Miranda


<Serializable()> _
 <TableMapping("tblconchiaveidentity", "tblconchiaveidentity", "IDValuta", "")> _
Partial Public Class tblconchiaveidentity
    Implements IEntity, INotifyPropertyChanged, INotifyPropertyChanging, IEditableObject

#Region "   Enum with Entity Properties binded to DB Table columns"
    Public Enum LinkedProperties
        IDValuta
        Valuta
        Cambio
        Nome
    End Enum
#End Region

#Region "   Private members generated from columns of the table"
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _IDValuta As SByte
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _Valuta As String
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _Cambio As Nullable(Of Single)
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _Nome As String
#End Region

    Private Sub SetDefaultValuesForBindedProperties()
        _Cambio = 1
    End Sub

    Public Sub New()
        SetDefaultValuesForBindedProperties() ' Set Defaults from DB Schema Infos

        _PreviousStatus = EntityStatus.Empty
        _Status = EntityStatus.Empty
    End Sub

    Public Sub Clear()
        _IDValuta = Nothing ' <-- else
        _Valuta = Nothing
        _Nome = Nothing

        ' Per i campi con un Default nel DB metto il Default
        SetDefaultValuesForBindedProperties() ' Set Defaults from DB Schema Infos

        _PreviousStatus = EntityStatus.Empty
        _Status = EntityStatus.Empty
    End Sub

#Region "   Public properties generated from columns of the table"

    <ColumnMappingAttribute("IDValuta", "TINYINT", True, True, False, 0, 4, 0)> _
  <Bindable(True)> _
    Public ReadOnly Property IDValuta As SByte
        Get
            Return _IDValuta
        End Get
    End Property

    <ColumnMappingAttribute("Valuta", "VARCHAR", False, False, False, 3, 0, 0)> _
  <Bindable(True)> _
    Public Property Valuta As String
        Get
            Return _Valuta
        End Get
        Set(ByVal Value As String)
            If (_Valuta Is Nothing And Value IsNot Nothing) _
                OrElse (_Valuta IsNot Nothing AndAlso Not _Valuta.Equals(Value)) Then
                OnPropertyChanging("Valuta")
                _Valuta = Value
                OnPropertyChanged("Valuta")
            End If
        End Set
    End Property

    <ColumnMappingAttribute("Cambio", "FLOAT", False, False, True, 0, 0, 0)> _
  <Bindable(True)> _
    Public Property Cambio As Nullable(Of Single)
        Get
            Return _Cambio
        End Get
        Set(ByVal Value As Nullable(Of Single))
            If (_Cambio Is Nothing And Value IsNot Nothing) _
                OrElse (_Cambio IsNot Nothing AndAlso Not _Cambio.Equals(Value)) Then
                OnPropertyChanging("Cambio")
                _Cambio = Value
                OnPropertyChanged("Cambio")
            End If
        End Set
    End Property

    <ColumnMappingAttribute("Nome", "VARCHAR", False, False, True, 12, 0, 0)> _
  <Bindable(True)> _
    Public Property Nome As String
        Get
            Return _Nome
        End Get
        Set(ByVal Value As String)
            If (_Nome Is Nothing And Value IsNot Nothing) _
                OrElse (_Nome IsNot Nothing AndAlso Not _Nome.Equals(Value)) Then
                OnPropertyChanging("Nome")
                _Nome = Value
                OnPropertyChanged("Nome")
            End If
        End Set
    End Property
#End Region

#Region "   IEntity implementation"
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
    Protected _Status As EntityStatus
    Public Event EntityChanged(ByVal sender As Object, ByVal e As EntityActionEventArgs) Implements Pezzoli.Data.Miranda.IEntity.EntityChanged

    Public Sub SetStatus(ByVal newStatus As Pezzoli.Data.Miranda.EntityStatus) Implements Pezzoli.Data.Miranda.IEntity.SetStatus
        If newStatus = _Status Then Exit Sub

        _PreviousStatus = _Status
        _Status = newStatus
        'RaiseEvent EntityChanged(Me, New EntityActionEventArgs())
        Select Case _Status
            Case EntityStatus.Editing
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.ModifyLoaded))
            Case EntityStatus.Empty
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.Create))
            Case EntityStatus.Loaded
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.Load))
        End Select
    End Sub

    <Bindable(False)> _
    <Browsable(False)> _
    Public ReadOnly Property Status As Pezzoli.Data.Miranda.EntityStatus Implements Pezzoli.Data.Miranda.IEntity.Status
        Get
            Return _Status
        End Get
    End Property
#End Region

#Region "   INotifyPropertyChanged implementation"
    Public Event PropertyChanged(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangedEventArgs) Implements System.ComponentModel.INotifyPropertyChanged.PropertyChanged

    Protected Sub OnPropertyChanged(ByVal field As String)
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(field))
        SetStatus(EntityStatus.Editing)
    End Sub
#End Region

#Region "   INotifyPropertyChanging implementation"
    Public Event PropertyChanging(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangingEventArgs) Implements System.ComponentModel.INotifyPropertyChanging.PropertyChanging

    Protected Sub OnPropertyChanging(ByVal field As String)
        RaiseEvent PropertyChanging(Me, New PropertyChangingEventArgs(field))
    End Sub
#End Region
#Region "   IEditableObject implementation"
    'Private _Editing as Boolean
    'Private _New As Boolean
    'Private _Parent As ....
    Protected _PreviousStatus As EntityStatus

    ' Private Table columns for original Values
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _Orig_IDValuta As SByte
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _Orig_Valuta As String
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _Orig_Cambio As Nullable(Of Single)
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _Orig_Nome As String
    '   Friend Sub SetParent(ByVal parent As ...)
    '      _Parent = parent
    '   End Sub

    Public Sub BeginEdit() Implements System.ComponentModel.IEditableObject.BeginEdit
        'If Not _Editing Then 
        If _Status = EntityStatus.Empty Or _Status = EntityStatus.Loaded Then
            _Orig_IDValuta = _IDValuta
            _Orig_Valuta = _Valuta
            _Orig_Cambio = _Cambio
            _Orig_Nome = _Nome
            '_Editing = True
            _PreviousStatus = _Status
            _Status = EntityStatus.Editing

            If _PreviousStatus = EntityStatus.Empty Then
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.ModifyNew))
            End If
            If _PreviousStatus = EntityStatus.Loaded Then
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.ModifyLoaded))
            End If
        End If
    End Sub

    Public Sub CancelEdit(ByVal propertyName As LinkedProperties)
        If HasChanges(propertyName) Then
            Select Case propertyName
                Case LinkedProperties.IDValuta
                    _IDValuta = _Orig_IDValuta
                    RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("IDValuta"))
                Case LinkedProperties.Valuta
                    _Valuta = _Orig_Valuta
                    RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("Valuta"))
                Case LinkedProperties.Cambio
                    _Cambio = _Orig_Cambio
                    RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("Cambio"))
                Case LinkedProperties.Nome
                    _Nome = _Orig_Nome
                    RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("Nome"))
            End Select

            If Not HasChanges() Then _Status = _PreviousStatus
        End If
        '_Editing = False
    End Sub

    Public Sub CancelEdit() Implements System.ComponentModel.IEditableObject.CancelEdit
        'If _New Then
        If _Status = EntityStatus.Empty Then
            '_Parent.Remove(Me)
        Else
            CancelEdit(LinkedProperties.IDValuta)
            CancelEdit(LinkedProperties.Valuta)
            CancelEdit(LinkedProperties.Cambio)
            CancelEdit(LinkedProperties.Nome)

            If _PreviousStatus = EntityStatus.Empty Then
                _Status = EntityStatus.Empty
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.UndoEditNew))
            Else
                _Status = EntityStatus.Loaded
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.UndoEditLoaded))
            End If
        End If
        '_Editing = False
    End Sub

    Public Sub EndEdit() Implements System.ComponentModel.IEditableObject.EndEdit
        '_Editing = False
        '_New = False
        _PreviousStatus = _Status
        _Status = EntityStatus.Loaded
        'RaiseEvent EntityChanged(Me, System.EventArgs.Empty)
        If _PreviousStatus = EntityStatus.Loaded Then
            RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.ConfirmEditLoaded))
        Else
            RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.ConfirmEditNew))
        End If
    End Sub

    Public Function GetOriginalValue(ByVal propertyName As LinkedProperties) As Object
        Select Case propertyName
            Case LinkedProperties.IDValuta
                Return _Orig_IDValuta
            Case LinkedProperties.Valuta
                Return _Orig_Valuta
            Case LinkedProperties.Cambio
                Return _Orig_Cambio
            Case LinkedProperties.Nome
                Return _Orig_Nome
            Case Else
                Return Nothing
        End Select
    End Function

    Public Function HasChanges(ByVal propertyName As LinkedProperties) As Boolean
        Select Case propertyName
            Case LinkedProperties.IDValuta
                If Not _IDValuta.Equals(_Orig_IDValuta) Then Return True
            Case LinkedProperties.Valuta
                If (_Valuta Is Nothing And _Orig_Valuta IsNot Nothing) _
                    OrElse (_Valuta IsNot Nothing AndAlso Not _Valuta.Equals(_Orig_Valuta)) Then
                    Return True
                End If
            Case LinkedProperties.Cambio
                If (_Cambio Is Nothing And _Orig_Cambio IsNot Nothing) _
                    OrElse (_Cambio IsNot Nothing AndAlso Not _Cambio.Equals(_Orig_Cambio)) Then
                    Return True
                End If
            Case LinkedProperties.Nome
                If (_Nome Is Nothing And _Orig_Nome IsNot Nothing) _
                    OrElse (_Nome IsNot Nothing AndAlso Not _Nome.Equals(_Orig_Nome)) Then
                    Return True
                End If
        End Select
        Return False
    End Function

    Public Function HasChanges() As Boolean
        'If _Status = Pezzoli.Data.Miranda.EntityStatus.Editing Then
        If HasChanges(LinkedProperties.IDValuta) _
            Or HasChanges(LinkedProperties.Valuta) _
            Or HasChanges(LinkedProperties.Cambio) _
            Or HasChanges(LinkedProperties.Nome) _
        Then
            Return True
        Else
            Return False
        End If
    End Function
#End Region


#Region "   Utilities"
    Public Shared Function MaxLength(ByVal propertyName As LinkedProperties) As Integer
        Select Case propertyName
            Case LinkedProperties.Valuta
                Return 3
            Case LinkedProperties.Nome
                Return 12
            Case Else
                Return Integer.MaxValue
        End Select
    End Function

    Public Shared Function DefaultValue(ByVal propertyName As LinkedProperties) As Object
        Select Case propertyName
            Case LinkedProperties.Cambio
                Return 1
            Case Else
                Return Nothing
        End Select
    End Function
#End Region
End Class