﻿
'_Template settings_________________________________________________________
' MyGen. Ver.: 1.3.0.9                                 
' Template   : Miranda x Vb.Net, ver. 1.8.4                                   
' Author     : Gianluca Pezzoli. @CopyRight 2010 Dott. Ing. Gianluca Pezzoli  
' DB Name    : test
' Table Name : tblsenzachiave
' Namespace  : test
' Entity     : tblsenzachiave
' FormBinding: Vero
' UndoChanges: Vero
' Language   : MySQL Connector/Net (VB.NET)
' DbTarget   : MySQL Connector/Net 
' User MetaDB: \\pezzolidell\e$\DatiNuovi\Clienti\Ambrosini\Applicazioni\Personale\Personale.Net\MyGen\UserMetaData.xml
' Created  on: 23/06/2010 18:53:52
'___________________________________________________________________________

Imports System
Imports System.ComponentModel
Imports Pezzoli.Data.Miranda

<Serializable()> _
 <TableMapping("tblsenzachiave", "tblsenzachiave", "", "")> _
Partial Public Class tblsenzachiave
    Implements IEntity, INotifyPropertyChanged, INotifyPropertyChanging, IEditableObject

#Region "   Enum with Entity Properties binded to DB Table columns"
    Public Enum LinkedProperties
        Intero
        TestoVariabile
        DataPiccola
        Reale
        Booleano
        VirgolaDoppia
    End Enum
#End Region

#Region "   Private members generated from columns of the table"
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _Intero As System.UInt32
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _TestoVariabile As String
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _DataPiccola As DateTime
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _Reale As Nullable(Of Single)
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _Booleano As Nullable(Of Boolean)
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _VirgolaDoppia As Nullable(Of Double)
#End Region

    Private Sub SetDefaultValuesForBindedProperties()
        _Booleano = 1
    End Sub

    Public Sub New()
        SetDefaultValuesForBindedProperties() ' Set Defaults from DB Schema Infos

        _PreviousStatus = EntityStatus.Empty
        _Status = EntityStatus.Empty
    End Sub

    Public Sub Clear()
        _Intero = Nothing ' <-- else
        _TestoVariabile = Nothing
        _DataPiccola = Nothing
        _Reale = 0
        _VirgolaDoppia = Nothing ' <-- else

        ' Per i campi con un Default nel DB metto il Default
        SetDefaultValuesForBindedProperties() ' Set Defaults from DB Schema Infos

        _PreviousStatus = EntityStatus.Empty
        _Status = EntityStatus.Empty
    End Sub

#Region "   Public properties generated from columns of the table"

    <ColumnMappingAttribute("Intero", "INT UNSIGNED", False, False, False, 0, 10, 0)> _
  <Bindable(True)> _
    Public Property Intero As System.UInt32
        Get
            Return _Intero
        End Get
        Set(ByVal Value As System.UInt32)
            If Not Value.Equals(_Intero) Then
                OnPropertyChanging("Intero")
                _Intero = Value
                OnPropertyChanged("Intero")
            End If
        End Set
    End Property

    <ColumnMappingAttribute("TestoVariabile", "VARCHAR", False, False, True, 60, 0, 0)> _
  <Bindable(True)> _
    Public Property TestoVariabile As String
        Get
            Return _TestoVariabile
        End Get
        Set(ByVal Value As String)
            If (_TestoVariabile Is Nothing And Value IsNot Nothing) _
                OrElse (_TestoVariabile IsNot Nothing AndAlso Not _TestoVariabile.Equals(Value)) Then
                OnPropertyChanging("TestoVariabile")
                _TestoVariabile = Value
                OnPropertyChanged("TestoVariabile")
            End If
        End Set
    End Property

    <ColumnMappingAttribute("DataPiccola", "DATETIME", False, False, False, 0, 0, 0)> _
  <Bindable(True)> _
    Public Property DataPiccola As DateTime
        Get
            Return _DataPiccola
        End Get
        Set(ByVal Value As DateTime)
            If Not Value.Equals(_DataPiccola) Then
                OnPropertyChanging("DataPiccola")
                _DataPiccola = Value
                OnPropertyChanged("DataPiccola")
            End If
        End Set
    End Property

    <ColumnMappingAttribute("Reale", "FLOAT", False, False, True, 0, 0, 0)> _
  <Bindable(True)> _
    Public Property Reale As Nullable(Of Single)
        Get
            Return _Reale
        End Get
        Set(ByVal Value As Nullable(Of Single))
            If (_Reale Is Nothing And Value IsNot Nothing) _
                OrElse (_Reale IsNot Nothing AndAlso Not _Reale.Equals(Value)) Then
                OnPropertyChanging("Reale")
                _Reale = Value
                OnPropertyChanged("Reale")
            End If
        End Set
    End Property

    <ColumnMappingAttribute("Booleano", "TINYINT UNSIGNED", False, False, True, 0, 1, 0)> _
  <Bindable(True)> _
    Public Property Booleano As Nullable(Of Boolean)
        Get
            Return _Booleano
        End Get
        Set(ByVal Value As Nullable(Of Boolean))
            If (_Booleano Is Nothing And Value IsNot Nothing) _
                OrElse (_Booleano IsNot Nothing AndAlso Not _Booleano.Equals(Value)) Then
                OnPropertyChanging("Booleano")
                _Booleano = Value
                OnPropertyChanged("Booleano")
            End If
        End Set
    End Property

    <ColumnMappingAttribute("VirgolaDoppia", "DOUBLE", False, False, True, 0, 0, 0)> _
  <Bindable(True)> _
    Public Property VirgolaDoppia As Nullable(Of Double)
        Get
            Return _VirgolaDoppia
        End Get
        Set(ByVal Value As Nullable(Of Double))
            If (_VirgolaDoppia Is Nothing And Value IsNot Nothing) _
                OrElse (_VirgolaDoppia IsNot Nothing AndAlso Not _VirgolaDoppia.Equals(Value)) Then
                OnPropertyChanging("VirgolaDoppia")
                _VirgolaDoppia = Value
                OnPropertyChanged("VirgolaDoppia")
            End If
        End Set
    End Property
#End Region

#Region "   IEntity implementation"
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
    Protected _Status As EntityStatus
    Public Event EntityChanged(ByVal sender As Object, ByVal e As EntityActionEventArgs) Implements Pezzoli.Data.Miranda.IEntity.EntityChanged

    Public Sub SetStatus(ByVal newStatus As Pezzoli.Data.Miranda.EntityStatus) Implements Pezzoli.Data.Miranda.IEntity.SetStatus
        If newStatus = _Status Then Exit Sub

        _PreviousStatus = _Status
        _Status = newStatus
        'RaiseEvent EntityChanged(Me, New EntityActionEventArgs())
        Select Case _Status
            Case EntityStatus.Editing
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.ModifyLoaded))
            Case EntityStatus.Empty
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.Create))
            Case EntityStatus.Loaded
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.Load))
        End Select
    End Sub

    <Bindable(False)> _
    <Browsable(False)> _
    Public ReadOnly Property Status As Pezzoli.Data.Miranda.EntityStatus Implements Pezzoli.Data.Miranda.IEntity.Status
        Get
            Return _Status
        End Get
    End Property
#End Region

#Region "   INotifyPropertyChanged implementation"
    Public Event PropertyChanged(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangedEventArgs) Implements System.ComponentModel.INotifyPropertyChanged.PropertyChanged

    Protected Sub OnPropertyChanged(ByVal field As String)
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(field))
        SetStatus(EntityStatus.Editing)
    End Sub
#End Region

#Region "   INotifyPropertyChanging implementation"
    Public Event PropertyChanging(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangingEventArgs) Implements System.ComponentModel.INotifyPropertyChanging.PropertyChanging

    Protected Sub OnPropertyChanging(ByVal field As String)
        RaiseEvent PropertyChanging(Me, New PropertyChangingEventArgs(field))
    End Sub
#End Region
#Region "   IEditableObject implementation"
    'Private _Editing as Boolean
    'Private _New As Boolean
    'Private _Parent As ....
    Protected _PreviousStatus As EntityStatus

    ' Private Table columns for original Values
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _Orig_Intero As System.UInt32
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _Orig_TestoVariabile As String
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _Orig_DataPiccola As DateTime
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _Orig_Reale As Nullable(Of Single)
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _Orig_Booleano As Nullable(Of Byte)
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _Orig_VirgolaDoppia As Nullable(Of Double)
    '   Friend Sub SetParent(ByVal parent As ...)
    '      _Parent = parent
    '   End Sub

    Public Sub BeginEdit() Implements System.ComponentModel.IEditableObject.BeginEdit
        'If Not _Editing Then 
        If _Status = EntityStatus.Empty Or _Status = EntityStatus.Loaded Then
            _Orig_Intero = _Intero
            _Orig_TestoVariabile = _TestoVariabile
            _Orig_DataPiccola = _DataPiccola
            _Orig_Reale = _Reale
            _Orig_Booleano = _Booleano
            _Orig_VirgolaDoppia = _VirgolaDoppia
            '_Editing = True
            _PreviousStatus = _Status
            _Status = EntityStatus.Editing

            If _PreviousStatus = EntityStatus.Empty Then
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.ModifyNew))
            End If
            If _PreviousStatus = EntityStatus.Loaded Then
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.ModifyLoaded))
            End If
        End If
    End Sub

    Public Sub CancelEdit(ByVal propertyName As LinkedProperties)
        If HasChanges(propertyName) Then
            Select Case propertyName
                Case LinkedProperties.Intero
                    _Intero = _Orig_Intero
                    RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("Intero"))
                Case LinkedProperties.TestoVariabile
                    _TestoVariabile = _Orig_TestoVariabile
                    RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("TestoVariabile"))
                Case LinkedProperties.DataPiccola
                    _DataPiccola = _Orig_DataPiccola
                    RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("DataPiccola"))
                Case LinkedProperties.Reale
                    _Reale = _Orig_Reale
                    RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("Reale"))
                Case LinkedProperties.Booleano
                    _Booleano = _Orig_Booleano
                    RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("Booleano"))
                Case LinkedProperties.VirgolaDoppia
                    _VirgolaDoppia = _Orig_VirgolaDoppia
                    RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("VirgolaDoppia"))
            End Select

            If Not HasChanges() Then _Status = _PreviousStatus
        End If
        '_Editing = False
    End Sub

    Public Sub CancelEdit() Implements System.ComponentModel.IEditableObject.CancelEdit
        'If _New Then
        If _Status = EntityStatus.Empty Then
            '_Parent.Remove(Me)
        Else
            CancelEdit(LinkedProperties.Intero)
            CancelEdit(LinkedProperties.TestoVariabile)
            CancelEdit(LinkedProperties.DataPiccola)
            CancelEdit(LinkedProperties.Reale)
            CancelEdit(LinkedProperties.Booleano)
            CancelEdit(LinkedProperties.VirgolaDoppia)

            If _PreviousStatus = EntityStatus.Empty Then
                _Status = EntityStatus.Empty
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.UndoEditNew))
            Else
                _Status = EntityStatus.Loaded
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.UndoEditLoaded))
            End If
        End If
        '_Editing = False
    End Sub

    Public Sub EndEdit() Implements System.ComponentModel.IEditableObject.EndEdit
        '_Editing = False
        '_New = False
        _PreviousStatus = _Status
        _Status = EntityStatus.Loaded
        'RaiseEvent EntityChanged(Me, System.EventArgs.Empty)
        If _PreviousStatus = EntityStatus.Loaded Then
            RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.ConfirmEditLoaded))
        Else
            RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.ConfirmEditNew))
        End If
    End Sub

    Public Function GetOriginalValue(ByVal propertyName As LinkedProperties) As Object
        Select Case propertyName
            Case LinkedProperties.Intero
                Return _Orig_Intero
            Case LinkedProperties.TestoVariabile
                Return _Orig_TestoVariabile
            Case LinkedProperties.DataPiccola
                Return _Orig_DataPiccola
            Case LinkedProperties.Reale
                Return _Orig_Reale
            Case LinkedProperties.Booleano
                Return _Orig_Booleano
            Case LinkedProperties.VirgolaDoppia
                Return _Orig_VirgolaDoppia
            Case Else
                Return Nothing
        End Select
    End Function

    Public Function HasChanges(ByVal propertyName As LinkedProperties) As Boolean
        Select Case propertyName
            Case LinkedProperties.Intero
                If Not _Intero.Equals(_Orig_Intero) Then Return True
            Case LinkedProperties.TestoVariabile
                If (_TestoVariabile Is Nothing And _Orig_TestoVariabile IsNot Nothing) _
                    OrElse (_TestoVariabile IsNot Nothing AndAlso Not _TestoVariabile.Equals(_Orig_TestoVariabile)) Then
                    Return True
                End If
            Case LinkedProperties.DataPiccola
                If Not _DataPiccola.Equals(_Orig_DataPiccola) Then Return True
            Case LinkedProperties.Reale
                If (_Reale Is Nothing And _Orig_Reale IsNot Nothing) _
                    OrElse (_Reale IsNot Nothing AndAlso Not _Reale.Equals(_Orig_Reale)) Then
                    Return True
                End If
            Case LinkedProperties.Booleano
                If (_Booleano Is Nothing And _Orig_Booleano IsNot Nothing) _
                    OrElse (_Booleano IsNot Nothing AndAlso Not _Booleano.Equals(_Orig_Booleano)) Then
                    Return True
                End If
            Case LinkedProperties.VirgolaDoppia
                If (_VirgolaDoppia Is Nothing And _Orig_VirgolaDoppia IsNot Nothing) _
                    OrElse (_VirgolaDoppia IsNot Nothing AndAlso Not _VirgolaDoppia.Equals(_Orig_VirgolaDoppia)) Then
                    Return True
                End If
        End Select
        Return False
    End Function

    Public Function HasChanges() As Boolean
        'If _Status = Pezzoli.Data.Miranda.EntityStatus.Editing Then
        If HasChanges(LinkedProperties.Intero) _
            Or HasChanges(LinkedProperties.TestoVariabile) _
            Or HasChanges(LinkedProperties.DataPiccola) _
            Or HasChanges(LinkedProperties.Reale) _
            Or HasChanges(LinkedProperties.Booleano) _
            Or HasChanges(LinkedProperties.VirgolaDoppia) _
        Then
            Return True
        Else
            Return False
        End If
    End Function
#End Region


#Region "   Utilities"
    Public Shared Function MaxLength(ByVal propertyName As LinkedProperties) As Integer
        Select Case propertyName
            Case LinkedProperties.TestoVariabile
                Return 60
            Case Else
                Return Integer.MaxValue
        End Select
    End Function

    Public Shared Function DefaultValue(ByVal propertyName As LinkedProperties) As Object
        Select Case propertyName
            Case LinkedProperties.Booleano
                Return 1
            Case Else
                Return Nothing
        End Select
    End Function
#End Region
End Class